<?php if (!defined('PmWiki')) exit();
/*
quickwikicms.php - Adds CMS features for PmWiki
Copyright 2016 by Hagan Fox
This program is distributed under the terms of the
GNU General Public License, Version 2

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, Version 2 as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/
SDV($QuickWikiCMSVersion, '2016-10-15');
##  Set RecipeInfo and create {$QuickWikiCMSVersion} page variable
SDV($RecipeInfo['QuickWikiCMS']['Version'], $QuickWikiCMSVersion);
SDV($FmtPV['$QuickWikiCMSVersion'],'$QuickWikiCMSVersion');

##  Add a custom page storage location for bundled pages.
#
$PageStorePath = dirname(__FILE__)."/wikilib-qwcms.d/\$FullName";
$where = count($WikiLibDirs);
if ($where>1) $where--;
array_splice($WikiLibDirs, $where, 0, array(new PageStore($PageStorePath)));

##  Create an uploads/ directory if uploads are enabled one doesn't exist.
#
SDV($UploadDir,'uploads'); // in case it was set in a config file
$dp = dirname($UploadDir);
if ($EnableUpload == 1 && !is_dir("$dp/$UploadDir") && is_writable($dp)) {
  mkdir("$dp/$UploadDir");
  // deny directory listing
  $up_one_level='<?php
/* index.php -- Builds up-one-level URL, then redirects the browser.  */
$Scheme = (@$_SERVER["HTTPS"]=="on" || @$_SERVER["SERVER_PORT"]==443)
             ? "https" : "http";
$DirName = dirname($_SERVER["REQUEST_URI"]);
$EndSlash = ($DirName == "/") ? "" : "/"; // except docroot
$RedirUrl = $Scheme."://".$_SERVER["HTTP_HOST"].$DirName.$EndSlash;
header("Location: $RedirUrl");'."\n\n";
  $indexfile="$dp/$UploadDir/index.php";
  $fp=@fopen($indexfile, "w"); fwrite($fp,$up_one_level); fclose($fp); 
}

##  Enable the Preferences page.
#
XLPage('quickwikicms', "$SiteGroup.CMSPreferences");
array_splice($XLLangs, -1, 0, array_shift($XLLangs));

##  Add {$UploadScratchName} and {$UploadScratchSize} page variables.
##  These are for the custom UploadQuickReference page.
#
if ($action == 'upload') {
  if (@$_REQUEST['upname']) $ScratchName = $_REQUEST['upname'];
  if (@$_REQUEST['uprname']) $ScratchName = $_REQUEST['uprname'];
  if (!empty($ScratchName)) {
    $FmtPV['$UploadScratchName'] =
      "'".htmlspecialchars($ScratchName, ENT_QUOTES)."'";
    global $ScratchExists; $ScratchExists = TRUE;
    $ScratchSize = round(($tmp=strlen($pagename.$ScratchName)+3)*1.3);
    $FmtPV['$UploadScratchSize'] = "'$ScratchSize'"; }
}

##  Set Adapt Skin poweredby string: "Powered by: PmWiki and Quick Wiki CMS"
#
SDV($AdaptPoweredBy,"Powered by: <a target='_blank'
          href='http://www.pmwiki.org/wiki' title='pmwiki.org'>PmWiki</a>
          and <a target='_blank' href='http://www.QuickWikiCMS.com/'
          title='QuickWikiCMS.com'>Quick Wiki CMS</a>\n");

